<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>Task 48.50</title>

    <!-- Google Font: Source Sans Pro -->
    <link
      rel="stylesheet"
      href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback"
    />
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css" />
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css" />
  </head>
  <body class="hold-transition sidebar-mini">
    <!-- Site wrapper -->
    <div class="wrapper">
      <!-- Navbar -->
      <nav class="main-header navbar navbar-expand navbar-white navbar-light">
        <!-- Left navbar links -->
        <ul class="navbar-nav">
          <li class="nav-item">
            <a class="nav-link" data-widget="pushmenu" href="#" role="button"
              ><i class="fas fa-bars"></i
            ></a>
          </li>
          <li class="nav-item d-none d-sm-inline-block">
            <a href="#" class="nav-link">Home</a>
          </li>
          <li class="nav-item d-none d-sm-inline-block">
            <a href="#" class="nav-link">User</a>
          </li>
        </ul>
      </nav>
      <!-- /.navbar -->

      <!-- Main Sidebar Container -->
      <aside class="main-sidebar sidebar-dark-primary elevation-4">
        <!-- Brand Logo -->
        <a href="index3.html" class="brand-link">
          <img
            src="dist/img/AdminLTELogo.png"
            alt="AdminLTE Logo"
            class="brand-image img-circle elevation-3"
            style="opacity: 0.8;"
          />
          <span class="brand-text font-weight-light">DEVCAMP</span>
        </a>

        <!-- Sidebar -->
        <div class="sidebar">
          <!-- Sidebar user (optional) -->
          <div class="user-panel mt-3 pb-3 mb-3 d-flex">
            <div class="image">
              <img
                src="dist/img/user2-160x160.jpg"
                class="img-circle elevation-2"
                alt="User Image"
              />
            </div>
            <div class="info">
              <a href="#" class="d-block">Le Nguyen</a>
            </div>
          </div>

          <!-- SidebarSearch Form -->
          <div class="form-inline">
            <div class="input-group" data-widget="sidebar-search">
              <input
                class="form-control form-control-sidebar"
                type="search"
                placeholder="Search"
                aria-label="Search"
              />
              <div class="input-group-append">
                <button class="btn btn-sidebar">
                  <i class="fas fa-search fa-fw"></i>
                </button>
              </div>
            </div>
          </div>

          <!-- Sidebar Menu -->
          <nav class="mt-2">
            <ul
              class="nav nav-pills nav-sidebar flex-column"
              data-widget="treeview"
              role="menu"
              data-accordion="false"
            >
              <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
              <li class="nav-item menu-open">
                <a href="#" class="nav-link active">
                  <i class="nav-icon fas fa-tachometer-alt"></i>
                  <p>
                    Dashboard
                    <i class="right fas fa-angle-left"></i>
                  </p>
                </a>
                <ul class="nav nav-treeview">
                  <li class="nav-item">
                    <a href="#" class="nav-link active">
                      <i class="far fa-circle nav-icon"></i>
                      <p>Home</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="#" class="nav-link">
                      <i class="far fa-circle nav-icon"></i>
                      <p>User</p>
                    </a>
                  </li>
                </ul>
              </li>
            </ul>
          </nav>
          <!-- /.sidebar-menu -->
        </div>
        <!-- /.sidebar -->
      </aside>

      <!-- Content Wrapper. Contains page content -->
      <div class="content-wrapper">
        <!-- Content Header (Page header) -->
        <section class="content-header">
          <div class="container-fluid">
            <div class="row mb-2">
              <div class="col-sm-6">
                <h1>F100 - QUẢN TRỊ NGƯỜI DÙNG</h1>
              </div>
              <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                  <li class="breadcrumb-item"><a href="#">Home</a></li>
                  <li class="breadcrumb-item active">User</li>
                </ol>
              </div>
            </div>
          </div>
          <!-- /.container-fluid -->
        </section>

        <!-- Main content -->
        <section class="content">
          <!-- Default box -->
          <div class="card">
            <div class="jumbotron container mt-3">
              <div class="row form-group mb-0">
                <div class="col-sm-3 text-right">
                  <label for="">Role</label>
                </div>
                <div class="col-sm-6">
                  <select
                    name=""
                    id="role-select"
                    class="form-control"
                  ></select>
                </div>
                <div class="col-sm-3">
                  <button id="btn-filter-role" class="btn btn-info">
                    Lọc dữ liệu
                  </button>
                </div>
              </div>
            </div>

            <div class="container">
              <table
                id="user-table"
                class="table table-bordered table-striped table-hover"
                style="width: 100%;"
              >
                <thead class="thead-dark">
                  <th>STT</th>
                  <th>Username</th>
                  <th>First name</th>
                  <th>Last name</th>
                  <th>Email</th>
                  <th>Age</th>
                  <th>Role</th>
                  <th>Action</th>
                </thead>
              </table>
            </div>
          </div>
          <!-- /.card -->
        </section>
        <!-- /.content -->
      </div>
      <!-- /.content-wrapper -->

      <footer class="main-footer">
        <div class="float-right d-none d-sm-block"><b>Version</b> 1.0.0</div>
        <strong>Copyright &copy; 2023 <a href="#">Devcamp</a>.</strong> All
        rights reserved.
      </footer>
    </div>
    <!-- ./wrapper -->

    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>

    <!-- Data Table-->
    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css"
    />
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  </body>
</html>

<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // Mảng gUserObjects là mảng chứa dữ liệu users
  var gUserObjects = [
    {
      id: 2,
      username: "quannv",
      firstname: "Ngo Van",
      lastname: "Quan",
      age: 18,
      email: "quan@gmail.com",
      roleId: 5,
    },
    {
      id: 3,
      username: "longdh",
      firstname: "Do Hoang",
      lastname: "Long",
      age: 19,
      email: "long@gmail.com",
      roleId: 8,
    },
    {
      id: 4,
      username: "hiendt",
      firstname: "Do Thi",
      lastname: "Hien",
      age: 29,
      email: "hien@gmail.com",
      roleId: 11,
    },
    {
      id: 6,
      username: "lanht",
      firstname: "Ho Thi",
      lastname: "Lan",
      age: 27,
      email: "lan@gmail.com",
      roleId: 13,
    },
  ];
  // Mảng gRoleObjects là mảng chứa dữ liệu các roles
  var gRoleObjects = [
    {
      roleId: 5,
      roleName: "Admin",
    },
    {
      roleId: 8,
      roleName: "Manager",
    },
    {
      roleId: 11,
      roleName: "Teacher",
    },
    {
      roleId: 13,
      roleName: "Staff",
    },
  ];

  var gNameCol = [
    "stt",
    "username",
    "firstname",
    "lastname",
    "email",
    "age",
    "roleId",
    "action",
  ];

  const gSTT_COL = 0;
  const gUSER_NAME_COL = 1;
  const gFIRST_NAME_COL = 2;
  const gLAST_NAME_COL = 3;
  const gEMAIL_COL = 4;
  const gAGE_COL = 5;
  const gROLE_COL = 6;
  const gACTION_COL = 7;
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  onPageLoading();
  $("#btn-filter-role").on("click", function () {
    onBtnLocDuLieuClick();
  });

  $(document).on("click", ".btn-dice-history", function () {
    onBtnHistoryDiceClick(this);
  });

  $(document).on("click", ".btn-voucher-history", function () {
    onBtnHistoryVoucherClick(this);
  });
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  //hàm thực thi khi tải trang
  function onPageLoading() {
    loadDataToRoleSelect();
    showTableUserDataTable();
  }

  //hàm thực thi khi nhấn nút Lọc dữ liệu
  function onBtnLocDuLieuClick() {
    var vFilterRoleId = {
      roleId: -1,
    };

    //B1: thu thập dữ liệu
    getFilterData(vFilterRoleId);
    //B3: xử lý filter
    filterRoles(vFilterRoleId);
  }

  //hàm thực thi khi nhấn nút icon Dice History
  function onBtnHistoryDiceClick(paramBtnElement) {
    var vDataRow = getDataRow(paramBtnElement);

    const vDETAIL_FORM_URL = "task 43.40.html";
    var vUrlSiteToOpen =
      vDETAIL_FORM_URL +
      "?user_name=" +
      vDataRow.username +
      "&first_name=" +
      vDataRow.firstname +
      "&last_name=" +
      vDataRow.lastname;
    location.href = vUrlSiteToOpen;
  }

  //hàm thực thi khi nhấn nút icon Voucher History
  function onBtnHistoryVoucherClick(paramBtnElement) {
    var vDataRow = getDataRow(paramBtnElement);

    const vDETAIL_FORM_URL = "voucherHistory.html";
    var vUrlSiteToOpen =
      vDETAIL_FORM_URL +
      "?user_name=" +
      vDataRow.username +
      "&first_name=" +
      vDataRow.firstname +
      "&last_name=" +
      vDataRow.lastname;
    location.href = vUrlSiteToOpen;
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //hàm load role lên Select Role trên ưeb
  function loadDataToRoleSelect() {
    var vRoleSelect = $("#role-select");
    $("<option/>", {
      text: "--- Chọn tất cả ---",
      value: 0,
    }).appendTo(vRoleSelect);

    for (let bI = 0; bI < gRoleObjects.length; bI++) {
      var bRoleOption = $("<option/>", {
        text: gRoleObjects[bI].roleName,
        value: gRoleObjects[bI].roleId,
      }).appendTo(vRoleSelect);
    }
  }

  //hàm load user lên table trên web
  function showTableUserDataTable() {
    $("#user-table").DataTable({
      data: gUserObjects,
      columns: [
        { data: gNameCol[gSTT_COL] },
        { data: gNameCol[gUSER_NAME_COL] },
        { data: gNameCol[gFIRST_NAME_COL] },
        { data: gNameCol[gLAST_NAME_COL] },
        { data: gNameCol[gEMAIL_COL] },
        { data: gNameCol[gAGE_COL] },
        { data: gNameCol[gROLE_COL] },
        { data: gNameCol[gACTION_COL] },
      ], // Các thuộc tính của USER sẽ match với từng column
      columnDefs: [
        //định nghĩa các cột cần hiện ra
        {
          targets: gSTT_COL, //cột STT
          className: "text-center text-primary",
          render: function (data, type, row, meta) {
            return meta.row + meta.settings._iDisplayStart + 1;
          },
        },
        {
          targets: gROLE_COL,
          className: "text-right",
          render: mappingRoleNameByID,
        },
        {
          targets: gACTION_COL, //cột Action
          className: "text-center",
          defaultContent: `
            <button class="btn btn-link btn-dice-history" data-toggle="tooltip" data-placement="bottom" title="Dice History"><i class="fas fa-dice text-success"></i></button>
            <button class="btn btn-link btn-sm btn-voucher-history" data-toggle="tooltip" data-placement="bottom" title="Voucher History"><i class="fas fa-gift text-success"></i></button>`,
        },
      ],
    });
  }

  //hàm render từ role id thành role name
  function mappingRoleNameByID(paramData, paramType, paramRow) {
    for (let bI = 0; bI < gRoleObjects.length; bI++) {
      const bRoleObjItem = gRoleObjects[bI];
      if (paramData == bRoleObjItem.roleId) {
        return bRoleObjItem.roleName;
      }
    }
  }

  //hàm thu thập dữ liệu để lọc
  function getFilterData(paramFilterObj) {
    paramFilterObj.roleId = parseInt($("#role-select").val(), 10);
  }

  //hàm lọc và load kết quả vào table
  function filterRoles(paramFilterObj) {
    var vRolesResult = [];
    vRolesResult = gUserObjects.filter(function (paramUser) {
      return (
        paramFilterObj.roleId === 0 ||
        paramUser.roleId === paramFilterObj.roleId
      );
    });
    console.log(vRolesResult);

    //load kết quả lên table
    $("#user-table").DataTable().clear();
    $("#user-table").DataTable().rows.add(vRolesResult);
    $("#user-table").DataTable().draw();
  }

  //hàm lấy data row dựa vào nút đã ấn
  function getDataRow(paramBtn) {
    var vRow = $(paramBtn).parents("tr");
    var vRowData = $("#user-table").DataTable().row(vRow).data();
    return vRowData;
  }
</script>
